#パンヤ絵文字プラグイン Ver 1.10 (2009/09/28)
#Copyright(C) 2009 CJ?GOROH All Rights Reserved.

package webliberty::Plugin::PangYaFace;

use strict;
use base qw(webliberty::Basis);

### コンストラクタ
sub new {
	my $class = shift;

	my $self = {
		init   => shift,
		config => shift,
		query  => shift,
	};
	bless $self, $class;

	require $self->{init}->{plugin_dir} . 'PangYaFace/init.cgi';

	$self->{plugin} = &webliberty::Plugin::PangYaFace::init::get_init;

	return $self;
}

### メイン処理
sub run {
	my $self = shift;

	my $result;
	my ($cnt, $i, $r_cnt) = 0;

	if ($self->{query}->{plugin}) {
		my $cols = ($self->{plugin}->{palette_cols} > 1) ? int($self->{plugin}->{palette_cols}) : 1;
		my $width = ($self->{plugin}->{palette_width} > 100) ? int($self->{plugin}->{palette_width}) : 100;
		print $self->header;
		print "<html>\n";
		print "<head>\n";
		print "<title>絵文字一覧</title>\n";
		unless ($ENV{'HTTP_USER_AGENT'} =~ /(DoCoMo|SoftBank|Vodafone|J-PHONE|KDDI-|UP\.Browser|DDIPOCKET|WILLCOM)/i) {
			print "<link rel=\"stylesheet\" href=\"$self->{plugin}->{css_path}PangYaFace.css\" type=\"text/css\" media=\"all\" />\n";
			print "<script type=\"text/javascript\" src=\"$self->{plugin}->{js_path}PangYaFace.js\"></script>\n";
			print "</head>\n";
			print "<body class=\"PangYaFace\">\n";
			print "<table>\n";
			for ($i = 0; $i < $cols; $i++) { print "<col width=\"$width\">"; }
		} else {
			$cols = 1;
			print "</head>\n";
			print "<body>\n";
			print "<h1>絵文字一覧</h1>\n";
			print "<p>前のページに戻るときは、端末で戻る操作を行ってください。</p>\n";
			print "<table>\n";
		}
		print "\n<tr>\n";
		foreach (@{$self->{plugin}->{face_list}}) {
			if ($_->[1] eq '') { next };
			$cnt++;
			if ($cnt > $cols) {
				print "\n</tr><tr>\n";
				$cnt = 1;
			}
			print "<td><img src=\"$self->{plugin}->{image_path}$_->[1]\" alt=\"（$_->[0]）\" /> （$_->[0]）</td>\n";
		}
		for ($i = $cnt; $i < $cols; $i++) { print "<td></td>"; }
		print "</tr>\n";
		print "</table>\n";
		print "<p class=\"PangYaCopy\">&copy;2004 Ntreev Soft Co.,Ltd. All Rights Reserved. Exclusive License &copy;2004 HanbitSoft, Inc., All rights reserved. &copy;2004 Gamepot Inc., All rights reserved.</p>";
		print "</body>\n";
		print "</html>\n";
		exit;
	} else {
		my $cols = ($self->{plugin}->{image_cols} > 3) ? int($self->{plugin}->{image_cols}) : 3;
		my $rows = ($self->{plugin}->{image_rows} > 1) ? int($self->{plugin}->{image_rows}) : 0;
		my $win_x = ($self->{plugin}->{palette_size_x} > 150 ) ? int($self->{plugin}->{palette_size_x}) : 150;
		my $win_y = ($self->{plugin}->{palette_size_y} > 150 ) ? int($self->{plugin}->{palette_size_y}) : 150;
		my $o_link = ($self->{plugin}->{palette_open} == 1) ? "\n<tr><td colspan=\"$cols\"><p><a href=\"$self->{init}->{script_file}?plugin=PangYaFace\" onclick=\"return FaceList('$self->{init}->{script_file}?plugin=PangYaFace', $win_x, $win_y);\" target=\"PangYaFace\">絵文字一覧</a></p></td></tr>\n" : '';
		$result = "<div class=\"PangYaFace\"><table class=\"PangYaFace\"><tr>\n";
		if ($self->{plugin}->{image_reverse} == 1) {
			foreach (@{$self->{plugin}->{face_list}}) {
				if ($_->[1] eq '') { next };
				$cnt++;
				if ($cnt > $cols) {
					$r_cnt ++;
					if ($rows && $r_cnt >= $rows) { last; }
					$result .= "\n</tr><tr>\n";
					$cnt = 1;
				}
				$result .= "<td><img src=\"$self->{plugin}->{image_path}$_->[1]\" alt=\"（$_->[0]）\" onclick=\"insertPangYaFace('（$_->[0]）');\" /></td>";
			}
		} else {
			foreach (@{$self->{plugin}->{face_list}}) {
				if ($_->[0] =~ /^＠/) { next; }
				if ($_->[1] eq '') { next; }
				$cnt++;
				if ($cnt > $cols) {
					$r_cnt ++;
					if ($rows && $r_cnt >= $rows) { last; }
					$result .= "\n</tr><tr>\n";
					$cnt = 1;
				}
				$result .= "<td><img src=\"$self->{plugin}->{image_path}$_->[1]\" alt=\"（$_->[0]）\" onclick=\"insertPangYaFace('（$_->[0]）');\" /></td>";
			}
		}
		for ($i = $cnt; $i < $cols; $i++) { $result .= "<td></td>"; }
		$result .= "$o_link\n</tr></table></div>\n";
	}

	return $result;
}

### 絵文字に置換
sub replace_header {
	my $html = shift;

	unless ($ENV{'HTTP_USER_AGENT'} =~ /(DoCoMo|SoftBank|Vodafone|J-PHONE|KDDI-|UP\.Browser|DDIPOCKET|WILLCOM)/i) {
		my $pfi = &webliberty::Plugin::PangYaFace::init::get_init;

		$html =~ s/<\/head>/<link rel="stylesheet" href="$pfi->{css_path}PangYaFace\.css" type="text\/css" media="all" \/>\n<\/head>/i;
		$html =~ s/<\/head>/<script type="text\/javascript" src="$pfi->{js_path}PangYaFace\.js"><\/script>\n<\/head>/i;
	}

	return $html;
}

sub replace_html {
	my $html = shift;

	my $pfi = &webliberty::Plugin::PangYaFace::init::get_init;

	my $class = ($ENV{'HTTP_USER_AGENT'} =~ /(DoCoMo|SoftBank|Vodafone|J-PHONE|KDDI-|UP\.Browser|DDIPOCKET|WILLCOM)/i) ? '' : ' class="pyf"';

	foreach (@{$pfi->{face_list}}) {
		if ($_->[1] eq '') { next };
		$html =~ s/(（$_->[0]）)/<img src="$pfi->{image_path}$_->[1]" alt="$1"$class \/>/ig;
	}

	return $html;
}

sub replace_footer {
	my $html = shift;

	my $pfi = &webliberty::Plugin::PangYaFace::init::get_init;

	if ($pfi->{footer} == 1) {
		my ($c_copy, $c_face, $i) = '';
		if ($ENV{'HTTP_USER_AGENT'} =~ /(DoCoMo|SoftBank|Vodafone|J-PHONE|KDDI-|UP\.Browser|DDIPOCKET|WILLCOM)/i) {
			$i = 'index.i.html';
		} else {
			$c_copy = ' class="PangYaCopy"';
			$c_face = ' class="PangYaFace"';
		}

		my $p_copy = "<p$c_copy>&copy;2004 Ntreev Soft Co.,Ltd. All Rights Reserved. Exclusive License &copy;2004 HanbitSoft, Inc., All rights reserved. &copy;2004 Gamepot Inc., All rights reserved.</p>";
		my $g_copy = "Skin.pm Edited &amp; パンヤ絵文字プラグイン by <a href=\"http://www7a.biglobe.ne.jp/~goroh/$i\">CJ？ごろう</a>";
		my $flg = $html =~ s/<\/address>/<\/address>\n<address$c_face>$g_copy<\/address>\n$p_copy/i;
		unless ($flg) {
			$html =~ s/<\/a>/<\/a>\n<br \/><p$c_face>$g_copy<\/p>\n$p_copy/i;
		}
	}

	return $html;
}

1;
