#パンヤ絵文字プラグイン Ver 1.10：設定ファイル
#Copyright(C) 2009 CJ?GOROH All Rights Reserved.

package webliberty::Plugin::PangYaFace::init;

use strict;

sub get_init {
	my $init;

	#絵文字を置いたディレクトリ
	$init->{image_path} = './lib/webliberty/Plugin/PangYaFace/image/';

	#PangYaFace.cssのあるディレクトリ
	$init->{css_path} = './lib/webliberty/Plugin/PangYaFace/css/';

	#PangYaFace.jsのあるディレクトリ
	$init->{js_path} = './lib/webliberty/Plugin/PangYaFace/js/';

	#プラグインによるページフッターの書き換え
	$init->{footer} = 1;


	#ページ内絵文字パレットの表示列数（最低は3）
	$init->{image_cols} = 9;

	#ページ内絵文字パレットの最大表示行数（0は全て表示）
	$init->{image_rows} = 0;

	#ページ内絵文字パレットに反転絵文字「（＠まじ）」とかを表示
	$init->{image_reverse} = 0;

	#ページ内絵文字パレットに絵文字一覧のウィンドウを開くリンクの設置
	$init->{palette_open} = 0;


	#絵文字一覧のウィンドウサイズ（横幅）（最低は150）
	$init->{palette_size_x} = 570;

	#絵文字一覧のウィンドウサイズ（高さ）（最低は150）
	$init->{palette_size_y} = 400;

	#絵文字一覧のウィンドウの絵文字表示列数（最低は1 携帯では常に1）
	$init->{palette_cols} = 4;

	#絵文字一覧のウィンドウの絵文字１つの枠幅（最低は100）
	$init->{palette_width} = 130;


### 文字と絵文字の対応設定 ###

	$init->{face_list} = [

['まじ','011.gif'],
['あせ','012.gif'],
['わら','013.gif'],
['しょぼ','014.gif'],
['にや','015.gif'],
['いかり','016.gif'],
['びっくり','017.gif'],
['ん','018.gif'],
['ういんく','019.gif'],
['ぐらさん','020.gif'],
['すき','021.gif'],
['かなし','022.gif'],
['わーん','023.gif'],
['うる','024.gif'],
['はず','025.gif'],
['ぎょ','026.gif'],
['げー','027.gif'],
['あれ','028.gif'],
['ぺこ','029.gif'],
['にこ','030.gif'],
['むふ','031.gif'],
['ひょえ','032.gif'],
['気まずい',''],
['拍手',''],
['ううん',''],
['三角帽子',''],

['はーと','033.gif'],
['だめだ','034.gif'],
['けーき','035.gif'],
['おくりもの','036.gif'],
['めーる','037.gif'],
['くち','038.gif'],
['ばら','039.gif'],
['にんじん','040.gif'],
['びーる','041.gif'],
['こーひー','042.gif'],
['わいん','043.gif'],
['ぺんぎん','044.gif'],
['ほね','045.gif'],
['でんき','046.gif'],
['でんわ','047.gif'],
['おんぷ','048.gif'],
['あくま','049.gif'],
['てんし','050.gif'],
['たいよう','051.gif'],
['ほのお','052.gif'],
['ゆき','053.gif'],
['なみだ','054.gif'],
['あめ','055.gif'],
['かみなり','056.gif'],
['ほし','057.gif'],
['かさ','058.gif'],
['時間',''],
['PP',''],
['爆竹',''],
['ケータイ',''],

['ちょき','059.gif'],
['ぐー','060.gif'],
['ぱー','061.gif'],
['ぴーす','062.gif'],
['ぐっど','063.gif'],
['ぶー','064.gif'],
['おーけー','065.gif'],
['まて','066.gif'],
['それ','067.gif'],

### キャディーなど
['ぴぴん','001.gif'],
['たんぷー','002.gif'],
['どるふ','003.gif'],
['てぃっきー','004.gif'],
['かでぃえ','005.gif'],
['くらぶ','006.gif'],
['ろろ','007.gif'],
['きゅーま','008.gif'],
['でんち','009.gif'],
['めだる','010.gif']

];

	return $init;
}

1;
